/*
* anonymoX client
* 	for Firefox
* 
* Author 	Nils Hügelmann	<nils@anonymox.net>
* Author 	Florian Prott	<florian@anonymox.net>
* Author 	Christian Otto	<chris@anonymox.net>
*
* www.anonymox.net
* 
* License: CC BY-NC-ND 3.0, see LICENSE.TXT or http://creativecommons.org/licenses/by-nc-nd/3.0/
* 
* Use at your own risk
* 
* This is the released, uncommented version of the code.
*/

"use strict";

var anonymox = {};

Components.utils.import("resource://anonymox/components.jsm", anonymox);


anonymox.overlayCommonDialog = {
	
	load : function () {
		let info = new anonymox.Info("overlay-commondialog.buildStatusBar");
		
		try {
			let args = window.arguments[0].QueryInterface(Ci.nsIWritablePropertyBag2).QueryInterface(Ci.nsIWritablePropertyBag);
			
			if (args.getProperty("promptType") != "promptUserAndPass") return;
			
			let proxyMatches = args.getProperty("text").match(/moz-proxy:\/\/([^:]+):(\d+)/);
			
			if (!proxyMatches) return;
			
			let host = proxyMatches[1];
			let port = proxyMatches[2];
			
			let gateway;
			
			anonymox.core.gatewayListCache.forEach(
				function(gw){
					if (gw.ip == host && gw.port == port)
						gateway = gw;
				}
			);
			
			if (gateway){
				
				
				
				if ( new Date().getTime() - gateway.lastDialogAuthTime < 10 * 1000){
					if (!gateway.fastDialogAuthCount)
						gateway.fastDialogAuthCount = 0;
					
					gateway.fastDialogAuthCount++;
					
					if (gateway.fastDialogAuthCount > 10){
						info.debug("too many authDialogs for " + gateway.id + " -> abort auth");

						gateway.fastDialogAuthCount = 0;
						
						window.close();
						return;
					}
				}
				
				gateway.lastDialogAuthTime = new Date().getTime();

				
				
				info.debug("auto-filling credentials for " + gateway.id);
				
				document.getElementById("loginTextbox").value = anonymox.config.user;
				document.getElementById("password1Textbox").value = anonymox.config.pass;
				
				document.getElementById("commonDialog").acceptDialog();
			}

		} catch(e){
			info.error("load: " + e);
		}
	}
};

window.addEventListener("load", anonymox.overlayCommonDialog.load, false);
